Replace jQuery UI Datepicker with native browser date fields when available
Description

Some browsers have started to implement the input type "date" and are rendering nice native date pickers.

Here's a patch that uses Rails' date_field instead of text_field. To still support browsers which are not implementing date fields, the

jQuery UI Datepickers are still rendered when date fields are not available.

This is especially useful on mobile devices where the jQuery UI Datepickers do not seem to work well, at least not in combination

with #19097 it seems.

Here's a nice list of browsers that support this feature: http://caniuse.com/#feat=input-datetime and here's a screenshot of what it

looks like on Chrome for OS X:

 native_datepicker.png 

Related issues:

Related to Redmine - Feature #19097: Responsive layout for mobile devices Closed

Related to Redmine - Feature #23892: Switch date pickers embedded in browsers... New

Related to Redmine - Defect #31077: "Icon for Datepicker" does not appear aft... Closed

Related to Redmine - Defect #31259: Redmine Datepicker does not show in Firefox Closed

Has duplicate Redmine - Feature #13509: Better mobile support: input with date Closed

Associated revisions

Revision 15375 - 2016-05-07 10:05 - Jean-Philippe Lang

Use HTML5 date input fields instead of text fields with jquery ui date pickers (#19468).

Patch by Jan Schulz-Hofen.

History

#1 - 2015-03-24 17:36 - Jan from Planio www.plan.io

- Related to Feature #19097: Responsive layout for mobile devices added

#2 - 2015-03-25 16:29 - Jan from Planio www.plan.io

- File 0001-Use-HTML5-date-input-fields-instead-of-text-fields-w.patch added

Revising the patch in order to also change date fields in issue queries/filters

#3 - 2015-03-25 16:29 - Jan from Planio www.plan.io

- File deleted (0001-Use-HTML5-date-input-fields-instead-of-text-fields-w.patch)

#4 - 2015-04-01 05:16 - Go MAEDA

I have tried the patch with Chrome (Mac).

It looks neat but ignores 'Start calendars on' setting.

#5 - 2015-04-01 07:23 - Go MAEDA

- Has duplicate Feature #13509: Better mobile support: input with date added

#6 - 2015-04-07 12:36 - Jan from Planio www.plan.io
Go MAEDA wrote:

It looks neat but ignores 'Start calendars on' setting.

 Yes, the same goes for the language. Since it's a browser widget, it follows the settings defined in the Operating System, not in Redmine. The HTML5

tag does not support supplying a "start calendar on" setting. So this is a limitation we would have to live with.

Redmine's "Start calendars on" setting is still useful for e.g. the Calendar view in projects, so we should keep it in any case.

#7 - 2016-05-01 03:18 - Go MAEDA

- File 19468-for-r15361.diff added

- Status changed from Needs feedback to New

- Target version set to 3.3.0

I slightly modified Jan's patch for the latest trunk(r15361).

Although it ignores 'Start calendars on' setting, I think this is not a problem because it respects the settings defined in the operating system as Jan

said.

Jan from Planio www.plan.io wrote:

This is especially useful on mobile devices where the jQuery UI Datepickers do not seem to work well, at least not in combination with #19097 it

seems.

 Absolutely. Redmine supports responsive layouts since 3.2.0. I suggest including this feature in Redmine 3.3.0.

#8 - 2016-05-07 10:06 - Jean-Philippe Lang

- Category set to UI

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

Committed, thanks.

#9 - 2016-07-01 17:25 - Toshi MARUYAMA

Jan from Planio www.plan.io wrote:

Go MAEDA wrote:

It looks neat but ignores 'Start calendars on' setting.

 Yes, the same goes for the language. Since it's a browser widget, it follows the settings defined in the Operating System, not in Redmine. The

HTML5 tag does not support supplying a "start calendar on" setting. So this is a limitation we would have to live with.

Redmine's "Start calendars on" setting is still useful for e.g. the Calendar view in projects, so we should keep it in any case.

 Ref: #23224.

#10 - 2016-08-23 18:21 - Luc Luc

Native date picker breaks Redmine Settings, see #23224.

Thanks,

Luc

#11 - 2016-09-22 14:57 - Toshi MARUYAMA

- Related to Feature #23892: Switch date pickers embedded in browsers or bundled in redmine added

#12 - 2017-01-02 12:09 - Kush Suryavanshi

Sorry, if this a stupid question - but, if we apply this patch, will we be able to use the "time" functionality that's mentioned in #5458? It seems that we

need to use JQuery input for #5458 but this patch will give preference to native pickers. Thanks for the help.

#13 - 2017-01-02 12:20 - Jan from Planio www.plan.io
Kush Suryavanshi wrote:

Sorry, if this a stupid question - but, if we apply this patch, will we be able to use the "time" functionality that's mentioned in #5458? It seems that

we need to use JQuery input for #5458 but this patch will give preference to native pickers. Thanks for the help.

 #5458 has not been committed to Redmine yet. There are native time pickers as well using <input type="time"> which can be used for #5458 if

implemented.

#14 - 2017-01-02 13:14 - Kush Suryavanshi

Thanks much Jan. Appreciate your prompt input.

#15 - 2019-05-05 13:41 - Marius BĂLTEANU

- Related to Defect #31077: "Icon for Datepicker" does not appear after status was changed. added

#16 - 2019-05-05 13:43 - Marius BĂLTEANU

- Related to Defect #31259: Redmine Datepicker does not show in Firefox  added
